# std::set<Key,Compare,Allocator>::value_comp

From cppreference.com
< cpp‎ | container‎ | set

std::set::value_compare value_comp() const; |  |

Returns the function object that compares the values. It is the same as key_comp.

### Parameters

(none)

### Return value

The value comparison function object.

### Complexity

Constant.

### Example

Run this code

    #include <iostream>
    #include <set>
    #include <utility>

    // Example module 97 key compare function
    struct ModCmp
    {
        bool operator()(int lhs, int rhs) const
        {
            return (lhs % 97) < (rhs % 97);
        }
    };

    int main()
    {
        std::set<int, ModCmp> cont{1, 2, 3, 4, 5};

        // Same behaviour as key_comp()
        auto comp_func = cont.value_comp();

        for (const int val{100}; const int key : cont)
        {
            const bool before = comp_func(key, val);
            const bool after = comp_func(val, key);

            std::cout << "Key (" << key << ") ";
            if (!before && !after)
                std::cout << "equivalent to key (" << val << ")\n";
            else if (before)
                std::cout << "goes before key (" << val << ")\n";
            else if (after)
                std::cout << "goes after key (" << val << ")\n";
            else
                std::unreachable();
        }
    }

Output:

    Key (1) goes before key (100)
    Key (2) goes before key (100)
    Key (3) equivalent to key (100)
    Key (4) goes after key (100)
    Key (5) goes after key (100)

### See also

key_comp | returns the function that compares keys (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/set/value_comp&oldid=135450"